import React from 'react';
import * as shiki from 'shiki';

let langs = ['javascript', 'typescript', 'python', 'java', 'c', 'cpp', 'csharp', 'go', 'html', 'css', 'scss', 'json', 'yaml', 'xml', 'markdown', 'bash', 'shell', 'powershell', 'sql', 'php', 'ruby', 'perl', 'rust', 'swift', 'kotlin', 'dart', 'r', 'lua', 'groovy', 'scala', 'haskell', 'elm', 'erlang', 'ocaml', 'fsharp', 'clojure', 'plaintext', 'dockerfile']

let highlight: { codeToHtml: (arg0: string, arg1: { lang: string; theme: string; }) => string | number | boolean | React.ReactElement<any, string | React.JSXElementConstructor<any>> | Iterable<React.ReactNode> | React.ReactPortal | null | undefined; };
(async () => {
    highlight = await shiki.createHighlighter({
    themes: ['everforest-dark', 'everforest-light'],
    langs: langs
});
})();

function UseHighlighter({content, lang, theme}: {content: string, lang: string, theme: string}): React.ReactNode {
    while (!highlight) {

    if(langs.includes(lang)){
        return highlight.codeToHtml(content, {
            lang: lang,
            theme: theme === 'light' ? 'everforest-light' : 'everforest-dark'
        });
    }
    else{
        return <code>{content}</code>
    }
}
}

export { UseHighlighter };

